      SUBROUTINE CALSKP(NP,P,NFIT,ANG,YUSE,YRUSE,YCALC,F)
C***** Calculates sum of four peaks for fitfun fit to diff data
C     INPUT PARAMETERS
C     P 1       Flat background
C     P 2       slope
C     P 3       spare
C     P 4       Factor F  weighting control        
C     P 5       PEAK TYPE (1=LOR,2=GAU,3=Voigt,4=Skewed Gaussian)
C     P 6       PEAK HEIGHT
C     P 7       PEAK WIDTH
C     P 8       PEAK POSN
C     p 9       PEAK MODIFIER (Gauss width for Voigt or
C               skewness (Gauss_width_LHS/RHS ratio) for Skewed peak
C     P 10      PEAK TYPE FOR 2ND COMPONENT... ETC...
C
C     all widths are HWHM
C
C***** simplified example program derived from FIRR and TAPPIT
      COMMON/EXTPC/YY(2100,5),YYIN(4),INPK
C***** Save calculated curves for additional treatment...
      DIMENSION P(NP),ANG(NFIT),YUSE(NFIT),YRUSE(NFIT),YCALC(NFIT)
     1,F(NFIT)
      DIMENSION Y(2100)
C
C***** Calculate y - no resolution effects
C
      ALN2=ALOG(2.0)
      SLN2=SQRT(ALN2)
      ASIG=SQRT(2*ALN2)
      PI=3.141592
      SPI=SQRT(PI)
      YYIN(1)=0.
      YYIN(2)=0.
      YYIN(3)=0.
      YYIN(4)=0.
      DO 1000 I=1,NFIT
      YY(I,1)=0.
      YY(I,2)=0.
      YY(I,3)=0.
      YY(I,4)=0.
      YY(I,5)=0.
      YCALC(I)=0.
1000  CONTINUE
1     CONTINUE
      INPK=0
      DO 2 III=5,20,5
C***** FOR ANY PEAKS PRESENT
      INPK=INPK+1
      IF(P(III).EQ.0) GO TO 2
C***** NOT THIS ONE
      YYIN(INPK)=1.
      IH=III+1
C***** Area
      IW=III+2
C***** Width
      IP=III+3
C***** Position
      IPMOD=III+4
C***** Modifier
      J=P(III)
C***** peak type
      IF(J.LT.1.OR.J.GT.4) GO TO 2
C***** Other types of peak not treated
      GO TO (30,20,40,50) J
20    CONTINUE
C***** Lorentzian function
      DO 21 I=1,NFIT
      Y(I)=0.
      ANGF=ANG(I)
      FF=(ANGF-P(IP))**2
      Y(I)=Y(I)+P(IH)*P(IW)/(FF+P(IW)**2)/PI
21    CONTINUE
      GO TO 202
30    CONTINUE
C***** Gaussian function
      DO 31 I=1,NFIT
      Y(I)=0.
      ANGF=ANG(I)
      FF=(ANGF-P(IP))**2
      Y(I)=Y(I)+P(IH)*EXP(-FF*ALN2/P(IW)**2)*SLN2/(SPI*P(IW))
31    CONTINUE
      GO TO 202
40    CONTINUE
c***** Voigt
      DO 41 I=1,NFIT
      Y(I)=0.
      ANGF=ANG(I)-P(IP)
      SIGMA=P(IPMOD)/ASIG
c***** gaussian width component
      XLOR=2.*P(IW)
c***** Lorenztian component full width as input
      CALL VOIGT(ANGF,SIGMA,XLOR,YVAL,DERX,DERS,DERG)
      Y(I)=P(IH)*YVAL
41    CONTINUE
      GO TO 202
50    CONTINUE
C***** skewed Gaussians  (2 curves LHS/RHS)
C***** Join centre is offset from CofG which is P(IP)
      ALF=P(IPMOD)
      XJOIN=P(IP)+0.5*P(IW)*(1.-ALF)/(SPI*SLN2)
      widlhs=P(IW)*2./(1.+ALF)
      widrhs=ALF*widlhs
c      write(6,666) xjoin,p(ip),p(iw),p(ih),alf,widlhs,widrhs
c666   format(' xjoin ',f10.5,'  cen/wid/area/a/l/r',6f10.5)
      DO 51 I=1,NFIT
      Y(I)=0
      ANGF=ANG(I)
      FF=(ANGF-XJOIN)**2
      IF(ANGF.LT.XJOIN) Y(I)=+P(IH)*(2./(1.+alf))*SLN2
     1 *EXP(-FF*ALN2/widlhs**2)/(SPI*widlhs)
      IF(ANGF.GT.XJOIN) Y(I)=P(IH)*(alf*2./(1.+alf))*SLN2
     1 *EXP(-FF*ALN2/widrhs**2)/(SPI*widrhs)
51    CONTINUE
      GO TO 202

202   DO 204 I=1,NFIT
      YY(I,INPK)=Y(I)
C***** Each component is saved for possible later use
204   CONTINUE
2     CONTINUE
c***** background is defined at centre of first peak
      DO 170 I=1,NFIT
      YY(I,5)=P(1)+P(2)*(ANG(I)-P(8))
C***** Flat background+slope
      YCALC(I)=YY(I,1)+YY(I,2)+YY(I,3)+YY(I,4)+YY(I,5)
170   CONTINUE
      DO 200 I=1,NFIT
      FFFF=YUSE(I)-YCALC(I)
      F(I)=FFFF
      IF(P(4).EQ.0..and.YRUSE(I).NE.0.) F(I)=FFFF/YRUSE(I)
C***** Invoke weighting
200   CONTINUE
      RETURN
      END
C LEVEL 2      SUBROUTINE VOIGT(X,SIGMA,GAMMA,YVAL,DERX,DERS,DERG)
      SUBROUTINE VOIGT(X,SIGMA,GAMMA,YVAL,DERX,DERS,DERG)
C
C *** VOIGT by WIFD Jun 84 ***
C
CC 9C
CH Calculates normalised Voigt function
C
CD...      VOIGT is the normalised VOIGT function; a convolution of a
CD      normalised Gaussian (half-width= sigma) and Lorentzian
CD      (Cauchy) function (full-width at half-height= width). The
CD      function is calculated by noting that the VOIGT function
CD      is, to within a scale factor, equal to the real part of the
CD      complex error function.
C            W.I.F.David            6-JUN-84
C            Neutron Division
C            RAL                  ext. 5179
C
      DOUBLE PRECISION WR,WI,XX,YY
C
      OVRTPI=0.564189584
      OVRT2=0.707106781
      BTEM=OVRT2/SIGMA
      ATEM=OVRTPI*BTEM
      XTEM=X*BTEM
      YTEM=0.5*GAMMA*BTEM
      XX= DBLE(XTEM)
      YY= DBLE(YTEM)
      CALL WERF(WR,WI,XX,YY)
      SWR=SNGL(WR)
      SWI=SNGL(WI)
      CTEM=ATEM*BTEM
      YVAL=ATEM*SWR
      DWRDX=-2.*(XTEM*SWR-YTEM*SWI)
      DWRDY= 2.*(YTEM*SWR+XTEM*SWI-OVRTPI)
      DERX=CTEM*DWRDX
      DERS=-ATEM*(SWR+DWRDX*XTEM+DWRDY*YTEM)/SIGMA
      DERG=0.5*CTEM*DWRDY
C
      RETURN
      END
C LEVEL 1      SUBROUTINE WERF(RS1,RS2,XX,YY)
      SUBROUTINE WERF(RS1,RS2,XX,YY)
C
C *** WERF by WIFD 25 May 84 ***
C
CC 9C
CH Weighted error function ???
C
      IMPLICIT DOUBLE PRECISION            (A-H,O-Z)
      DOUBLE PRECISION                  LAMBDA
      LOGICAL                  B
C
      X=DABS(XX)
      Y=DABS(YY)
      IF (Y .LT. 4.29 .AND. X .LT. 5.33) GO TO 1
      H= 0.
      NC= 0
      NU= 8
      LAMBDA= 0.
      B= .TRUE.
      GO TO 2
 1      S=(1.0-Y/4.29)*DSQRT(1.0-X**2/28.41)
      H=1.6*S
      H2=2.0*H
      NC=6+IDINT(23.0*S)
      NU=9+IDINT(21.0*S)
      LAMBDA=H2**NC
      B=LAMBDA .EQ. 0.
 2      R1=0.
      R2=0.
      S1=0.
      S2=0.
      N=NU+1
 3      N=N-1
      FN=N+1
      T1=Y+H+FN*R1
      T2=X-FN*R2
      C=0.5/(T1**2+T2**2)
      R1=C*T1
      R2=C*T2
      IF (H .LE. 0.0 .OR. N .GT. NC) GO TO 4
      T1= LAMBDA+S1
      S1=R1*T1-R2*S2
      S2=R2*T1+R1*S2
      LAMBDA=LAMBDA/H2
 4      IF (N .GT. 0) GO TO 3
      IF (B) GO TO 6
      RS1=S1
      RS2=S2
      GO TO 7
 6      RS1=R1
      RS2=R2
 7      RS1= 1.12837916709551*RS1
      IF (Y .EQ. 0.0) RS1= DEXP(-X**2)
      RS2= 1.12837916709551*RS2
      IF (XX .LT. 0) RS2= -RS2
      RETURN
      END
